;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Scrolling Text
;================================

@Laddr=09D8		;Locate line address
@Seed=4032		;Line number to locate
@SPosn=4039		;PRINT AT coordinates
@LocAddr=091C		;Locate DFile addr
@LastK=4025		;Key press value
@Text=403C		;Text data
@End=403E		;PRINT AT address
@Start=4040		;Line start

@ScrollTxt
	LD HL,(Seed)	;Get DATA line number
	CALL Laddr	;Find it's address
	LD BC,0004	;Skip line header bytes
	ADD HL,BC	;HL=Start address of DATA
	LD (Text),HL	;Save text pointer
	PUSH HL		;PUSH text pointer
	LD BC,(SPosn)	;Get PRINT position
	CALL LocAddr	;Locate DFile address
	LD (End),HL	;Save PRINT AT address
	LD BC,001E
	AND A
	SBC HL,BC
	LD (Start),HL	;Save scroll line start address
	POP DE		;POP text pointer
@Loop
	PUSH DE		;PUSH text pointer
	LD BC,001F	;Setup for LDIR
	LD HL,(Start)	;Scroll line left
	LD D,H
	LD E,L
	DEC DE
	LDIR
	POP DE		;POP text pointer
@Rewind
	INC DE
	LD A,(DE)	;Get chr. to print
	BIT 6,A		;EOL marker?
	JR Z +6		;Jump if not EOL
	LD DE,(Text)	;Get start of text data
	JR Rewind
	LD HL,(End)	;Get PRINT AT address
	LD (HL),A	;Print chr.
;Check for keypress
	LD A,(LastK)	;Get keyboard status
	CP FF		;Key pressed?
	JR NZ Wait	;Jump if keypress
	LD BC,1001	;Speed, POKEd from BASIC
@DLay
	DEC BC		;Decrease counter
	LD A,B 
	OR C 
	JR NZ DLay	;Loop until BC=0
	JR Loop
@Wait
	LD A,(LastK)	;Get keyboard status
	CP FF		;Key pressed?
	JR NZ Wait	;Jump if keypress
	RET
